[<prev] [next>] [<thread-prev] [day] [month] [year] [list]
Message-ID: <714c3712-a390-ac60-40d4-c759b326e3c5@alu.unizg.hr>
Date: Tue, 3 Jan 2023 22:17:49 +0100
From: Mirsad Goran Todorovac <mirsad.todorovac@....unizg.hr>
To: Florian Westphal <fw@...len.de>
Cc: linux-kselftest@...r.kernel.org,
LKML <linux-kernel@...r.kernel.org>,
Shuah Khan <shuah@...nel.org>, Jakub Kicinski <kuba@...nel.org>
Subject: Re: PROBLEM: Hang in selftests/netfilter/nft_trans_stress.sh
On 03. 01. 2023. 17:11, Florian Westphal wrote:
> Mirsad Goran Todorovac <mirsad.todorovac@....unizg.hr> wrote:
>>> Can you send me the output of 'bash -x nft_trans_stress.sh'?
>>> It should tell which command/program isn't making progress.
>>
>> Hi, Florian!
>>
>> Well, when ran alone, the script ended successfully:
>>
>> root@...vin-IdeaPad-3-15ITL6:/home/marvin/linux/kernel/linux_torvalds/tools/testing/selftests/netfilter# bash nft_trans_stress.sh
>> PASS: nft add/delete test returned 0
>> PASS: nft reload test returned 0
>> PASS: nft add/delete with nftrace enabled test returned 0
>> PASS: nft add/delete with nftrace enabled test returned 0
>> root@...vin-IdeaPad-3-15ITL6:/home/marvin/linux/kernel/linux_torvalds/tools/testing/selftests/netfilter#
>>
>> There was no stall after "nft reload test" in a standalone superuser run.
>
> Hmm. Does this patch make it work when running via 'make kselftest'?
>
> diff --git a/tools/testing/selftests/netfilter/nft_trans_stress.sh b/tools/testing/selftests/netfilter/nft_trans_stress.sh
> --- a/tools/testing/selftests/netfilter/nft_trans_stress.sh
> +++ b/tools/testing/selftests/netfilter/nft_trans_stress.sh
> @@ -10,12 +10,20 @@
> ksft_skip=4
>
> testns=testns-$(mktemp -u "XXXXXXXX")
> +tmp=""
>
> tables="foo bar baz quux"
> global_ret=0
> eret=0
> lret=0
>
> +cleanup() {
> + ip netns pids "$testns" | xargs kill 2>/dev/null
> + ip netns del "$testns"
> +
> + rm -f "$tmp"
> +}
> +
> check_result()
> {
> local r=$1
> @@ -43,6 +51,7 @@ if [ $? -ne 0 ];then
> exit $ksft_skip
> fi
>
> +trap cleanup EXIT
> tmp=$(mktemp)
>
> for table in $tables; do
> @@ -139,11 +148,4 @@ done
>
> check_result $lret "add/delete with nftrace enabled"
>
> -pkill -9 ping
> -
> -wait
> -
> -rm -f "$tmp"
> -ip netns del "$testns"
> -
> exit $global_ret
I've got the following output:
make[2]: Entering directory '/home/marvin/linux/kernel/linux_torvalds/tools/testing/selftests/netfilter'
TAP version 13
1..17
# selftests: netfilter: nft_trans_stress.sh
# PASS: nft add/delete test returned 0
# PASS: nft reload test returned 0
#
not ok 1 selftests: netfilter: nft_trans_stress.sh # TIMEOUT 45 seconds
# selftests: netfilter: nft_fib.sh
# PASS: fib expression did not cause unwanted packet drops
It did not hang, but still did not finish all 4 tests correctly like when ran standalone:
root@...vin-IdeaPad-3-15ITL6:/home/marvin/linux/kernel/linux_torvalds/tools/testing/selftests/netfilter# time ./nft_trans_stress.sh
PASS: nft add/delete test returned 0
PASS: nft reload test returned 0
PASS: nft add/delete with nftrace enabled test returned 0
PASS: nft add/delete with nftrace enabled test returned 0
real 1m11.014s
user 0m6.470s
sys 0m20.344s
root@...vin-IdeaPad-3-15ITL6:/home/marvin/linux/kernel/linux_torvalds/tools/testing/selftests/netfilter#
I hope we're closer to the solution.
Kind regards,
Mirsad
--
Mirsad Goran Todorovac
Sistem inženjer
Grafički fakultet | Akademija likovnih umjetnosti
Sveučilište u Zagrebu
--
System engineer
Faculty of Graphic Arts | Academy of Fine Arts
University of Zagreb, Republic of Croatia
The European Union
Powered by blists - more mailing lists